// qmUnitQuaternion.h++

#ifndef _qmUnitQuaternion_H_
#define _qmUnitQuaternion_H_

#include "QuickMath/qmUnitQuaternionRef.h++"
#include "QuickMath/qmVector.h++"

class qmUnitQuaternion : public qmUnitQuaternionRef
{
    real storage[4];
public:
    qmUnitQuaternion() { qmUnitQuaternionRef::set( storage ); }
    inline qmUnitQuaternionRef& operator=( const qmUnitQuaternionRef& );
};

inline
qmUnitQuaternionRef&
qmUnitQuaternion::operator=( const qmUnitQuaternionRef& uq )
{
    qmVectorRef::copy( uq );
    return *this;
}

typedef qmUnitQuaternion qmQuat;

#endif /* _qmUnitQuaternion_H_ */
