// qmVectorArrayRef.c++

#include "qmVectorArrayRef.h++"

qmVectorArrayRef::qmVectorArrayRef()
  : ref(), mem( 0 ), elementCount( 0 ), elementSize( 0 )
{}

qmVectorArrayRef::qmVectorArrayRef( qmVectorRef& vr, int n )
  : ref(), mem( 0 ), elementCount( 0 ), elementSize( 0 )
{
    set( vr, n );
}

void
qmVectorArrayRef::set( qmVectorRef& vr, int n )
{
    if( mem )
       delete [] mem;
    elementCount = n;
    elementSize = vr.getByteCount();
    mem = new char[ n * elementSize ];
    ref = vr;
    ref.referTo( mem );
}

