#include <Creature.hh>

static Creature *data;

typedef float real;

void init_dataarray(real dt)
{
  data = new Creature;
  data->setDt(dt);
  data->setN(5000);
  
  data->addVariable("right.x","meters");
  data->addVariable("right.y","meters");
  data->addVariable("right.z","meters");
  data->addVariable("right.Ix","meters");
  data->addVariable("right.Iy","meters");
  data->addVariable("right.Iz","meters");
  data->addVariable("left.x","meters");
  data->addVariable("left.y","meters");
  data->addVariable("left.z","meters");
  data->addVariable("left.Ix","meters");
  data->addVariable("left.Iy","meters");
  data->addVariable("left.Iz","meters");
  data->addVariable("head.x","meters");
  data->addVariable("head.y","meters");
  data->addVariable("head.z","meters");
  data->addVariable("head.Ix","meters");
  data->addVariable("head.Iy","meters");
  data->addVariable("head.Iz","meters");
}

void update_dataarray(real rx, real ry, real rz, real rix, real riy, real riz,
		      real lx, real ly, real lz, real lix, real liy, real liz,
		      real hx, real hy, real hz, real hix, real hiy, real hiz)
{
  static unsigned long index = 0;

  data->setN(index+1);

  (*data)[ 0][index] = rx;
  (*data)[ 1][index] = ry;
  (*data)[ 2][index] = rz;
  (*data)[ 3][index] = rix;
  (*data)[ 4][index] = riy;
  (*data)[ 5][index] = riz;
  (*data)[ 6][index] = lx;
  (*data)[ 7][index] = ly;
  (*data)[ 8][index] = lz;
  (*data)[ 9][index] = lix;
  (*data)[10][index] = liy;
  (*data)[11][index] = liz;
  (*data)[12][index] = hx;
  (*data)[13][index] = hy;
  (*data)[14][index] = hz;
  (*data)[15][index] = hix;
  (*data)[16][index] = hiy;
  (*data)[17][index] = hiz;

  index ++;
}

void dump_dataarray()
{
  cout << *((AsciiCreature *) data);
}
