// Hand.h++

#ifndef _Hand_H_
#define _Hand_H_

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoCube.h>

class Hand
{
    static SoNode* handGeometry;
    SoSeparator* root;
    SoMaterial* material;
    SoTransform* xform;
    
 public:
    Hand();
    SoNode* getNode() { return root; }
    void set( int whichAxis, int plusOrMinus );
};

#endif /* _Hand_H_ */
