#include <iostream.h>
#include <string.h>
#include <sffinder/SffFile.h++>
#include <QuickMath/QuickMath-double.h++>
#include <QuickMath/qmUnitQuaternionRef.h++>

main()
{
  SffFile sffile;
  sffile.scan( cin );
  
  qmVector         T(3,sffile.world_t);
  qmMatrix         R(3,3,sffile.world_r);
  double           s = sffile.world_scale;
  qmVector         t(3,sffile.stereo_t);
  qmUnitQuaternion q; q.copy(qmVectorRef(4,sffile.stereo_q));

  qmVectorRef         new_T(3,sffile.world_t);
  qmMatrixRef         new_R(3,3,sffile.world_r);
  double              new_s = sffile.world_scale;
  qmVectorRef         new_t(3,sffile.stereo_t);
  qmUnitQuaternionRef new_q(sffile.stereo_q);

  qmVector         tmp(3);
  qmMatrix         tmpR(3,3);

  new_s = s;

  new_R.setTMultiply(q.getRotationMatrix(tmpR),R);

  tmp.setTMultiply(q.getRotationMatrix(tmpR), T);
  new_T.setAdd(tmp,t);

  new_q.setInvert(q);
  
  tmp.setNegate(t);
  new_t.setMultiply(new_q.getRotationMatrix(tmpR), tmp);
  
  sffile.world_scale = new_s;

  char buf[256];
  strcpy(buf,sffile.ffinder_left);
  strcpy(sffile.ffinder_left,sffile.ffinder_right);
  strcpy(sffile.ffinder_right,buf);

  sffile.print( cout );
}
