// qmMinMax.h++

#ifndef _qmMinMax_H_
#define _qmMinMax_H_

template < class T_ >
inline
T_
max( const T_ a, const T_ b )
{
  return( (a > b) ? a : b );
}

template < class T_ >
inline
T_
min( const T_ a, const T_ b )
{
  return( (a < b) ? a : b );
}

template < class T_ >
inline
T_
limit( const T_ a, const T_ low, const T_ high )
{
  return min( high, max(low, a ) );
}

#endif /* _qmMinMax_H_ */
