// qmStatistics.h++

#ifndef _qmStatistics_H_
#define _qmStatistics_H_

#include "qmStatistics/qmGaussianRef.h++"
#include "qmStatistics/qmGaussian.h++"
#include "qmStatistics/qmGaussianInvRef.h++"
#include "qmStatistics/qmGaussianInv.h++"
#include "qmStatistics/qmSampleAccRef.h++"
#include "qmStatistics/qmSampleAcc.h++"
#include "qmStatistics/qmKMeans.h++"

class qmStatistics
{

 public:
    static int invert( const qmGaussianRef& in, qmGaussianInvRef& out );
    static int invert( const qmGaussianInvRef& in, qmGaussianRef& out );
};


#endif /* _qmStatistics_H_ */
