// FfinderClient.h++

#ifndef _FfinderClient_H_
#define _FfinderClient_H_

#include <rpc/rpc.h>
#include <unistd.h>
// #include <math.h>
#include "ffinder_clnt.h"

class FfinderClient
{
    CLIENT* leftClient;
    CLIENT* rightClient;
    char* leftServerHost;
    char* rightServerHost;
    ffPerson leftPerson;
    ffPerson rightPerson;
    // ffConfig leftConfig = { 0, 128 };
    // ffConfig rightConfig = { 0, 128 };
    int currentFrameNumber;
public:
    FfinderClient();
    int connect( char* left, char* right );
    void callCaptureFrames();
    void callGetResults();
    void callGetPerson();
    int callGetCurrent();
    const ffPerson& getLeftPerson() { return leftPerson; }
    const ffPerson& getRightPerson() { return rightPerson; }
};

#endif /* _FfinderClient_H_ */
