// IvCameraTextField.h++

#ifndef _IvCameraTextField_H_
#define _IvCameraTextField_H_

#include <Inventor/nodes/SoText2.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoColorIndex.h>

class IvCameraTextField
{
    SoSeparator* root;
    SoTransform* xform;
    SoColorIndex* colorIndex;
    SoText2* text;
 public:
    IvCameraTextField();
    void setText( const char* );
    void setColor( int );
    void setLocation( float u, float v );
    SoNode* getNode() { return root; }
};

#endif /* _IvCameraTextField_H_ */
